// $Id: Gandharva.cpp,v 1.21 2001/06/12 10:48:55 Yoshi Exp $
// Copyright (C) 2000,2001 HOSHINO Yoshifumi
// {vO̓t[E\tgEFAłBρEĔzz GNU GPL o[WQ
// i͂ȍ~jQƂĂB

#include <windowsx.h>
#include <tchar.h>
#include "lsapi.h"
#include "Gandharva.h"

#define BUILD_NAME		TEXT("Gandharva.dll")
#define BUILD_VERSION	TEXT("v0.30c")
#define BUILD_DATE		TEXT("2001/06/12")
#define BUILD_AUTHOR	TEXT("Yoshi")


UINT nMessages[] = {
  LM_GETREVID,
  0
};


/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	RXgN^
		EBhẼZbgAbv
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
Gandharva::Gandharva( HWND parent, HINSTANCE lsinstance )
{
  LRESULT lresult;

  //xxxxxxxxxxxxxxxxxxxxVXȅ
  m_hLitestep = GetLitestepWnd();
  m_hInstance = lsinstance;
  m_hDesktop = FindWindow(WC_LSDESKTOP, NULL);

  m_pSettings = NULL;
  m_pWinampFunc = NULL;

  if(!m_hDesktop)
    m_hDesktop = GetDesktopWindow();

  //xxxxxxxxxxxxxxxxxxxxEChENX
  WNDCLASSEX wc;

  wc.cbSize = sizeof(WNDCLASSEX);
  wc.style = CS_DBLCLKS | CS_GLOBALCLASS;
  wc.lpfnWndProc = (WNDPROC) Gandharva::WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 4;
  wc.hInstance = m_hInstance;
  wc.hCursor = LoadCursor( NULL, IDC_ARROW );
  wc.hIcon = NULL;
  wc.hIconSm = NULL;
  wc.hbrBackground = NULL;
  wc.lpszMenuName = NULL;
  wc.lpszClassName = WINDOWCLASS_DLL;

  if (!RegisterClassEx( &wc ) ) {
    MessageBox(0,TEXT("failed to register window class."),WINDOWCLASS_DLL,MB_OK|MB_SYSTEMMODAL);
    return;
  }

  //xxxxxxxxxxxxxxxxxxxxEChE̍쐬
  m_hWnd = CreateWindowEx( WS_EX_TOOLWINDOW,//|WS_EX_TRANSPARENT,
                         WINDOWCLASS_DLL, NULL, WS_POPUP,
                         0, 0, 0, 0,
                         m_hDesktop, NULL, m_hInstance, (LPVOID)this);

  if (!m_hWnd) {
    MessageBox(0,TEXT("failed to create window."),WINDOWCLASS_DLL,MB_OK|MB_SYSTEMMODAL);
    return;
  }

  //xxxxxxxxxxxxxxxxxxxxLITESTEP ɃW[o^
  SendMessage( m_hLitestep, LM_REGISTERMESSAGE, (WPARAM) m_hWnd, (LPARAM) nMessages );
  SetWindowLong( m_hWnd, GWL_USERDATA, (LONG)MAGICDWORD );

  //xxxxxxxxxxxxxxxxxxxxݒ̓ǂݍ݂Ɣf
  m_pSettings = new GandharvaSettings(m_hWnd);

  if(!m_pSettings){
    MessageBox(0, "failed to load settings.", WINDOWCLASS_DLL, MB_OK|MB_SYSTEMMODAL);
    return;
  }

  SetWindowPos(m_hWnd,
               (m_pSettings->m_bAlwaysOnTop) ? HWND_TOPMOST : HWND_TOP,
               0,
               0,
               m_pSettings->m_Width,
               m_pSettings->m_Height,
               SWP_NOMOVE|SWP_NOACTIVATE);

  SetWndPos();

  //xxxxxxxxxxxxxxxxxxxx Ia`mf̒ǉ
  AddBangCommand("!GandharvaToggle", bangToggleVisible);
  AddBangCommand("!GandharvaToggleTime", bangToggleTime);
  AddBangCommand("!GandharvaShow", bangShow);
  AddBangCommand("!GandharvaHide", bangHide);
  AddBangCommand("!GandharvaDispMenu", bangDispMenu);
  AddBangCommand("!GandharvaSndvol", bangRunSndvol);

  if(m_pSettings->m_swCmdMode){
    AddBangCommand("!GandharvaCmdPrev", bangAmpPrev);
    AddBangCommand("!GandharvaCmdPlay", bangAmpPlay);
    AddBangCommand("!GandharvaCmdPause", bangAmpPause);
    AddBangCommand("!GandharvaCmdStop", bangAmpStop);
    AddBangCommand("!GandharvaCmdNext", bangAmpNext);
    AddBangCommand("!GandharvaCmdPLEdit", bangAmpPLEdit);
    AddBangCommand("!GandharvaCmdOpenFile", bangAmpOpenFile);
    AddBangCommand("!GandharvaCmdPower", bangAmpPower);
    AddBangCommand("!GandharvaCmdExtension", bangAmpCommand);
  }
  //xxxxxxxxxxxxxxxxxxxx winampt@NV
  char *buf=new char[256];

  //ftHg
  if(NULL == *m_pSettings->m_lpszTitleDefault)
    onLmGetRevid(LM_GETREVID, 0, (LPARAM)buf, &lresult);
  else
    strcpy(buf, m_pSettings->m_lpszTitleDefault);

  m_pWinampFunc = new CWinampFunction(buf);

  delete buf;

  //xxxxxxxxxxxxxxxxxxxx^C}[
  if(NULL == (m_rtimer = SetTimer(m_hWnd, TIMERID_RECYCLE_DISPLAY, 1000, NULL)))
    MessageBox(0,TEXT("Fail to create timer for title refresh."),WINDOWCLASS_DLL,MB_OK|MB_SYSTEMMODAL);

  m_stimer = NULL;

  //؂ĂǂH
  onTimer(WM_TIMER, TIMERID_RECYCLE_DISPLAY, 0, &lresult);

  //xxxxxxxxxxxxxxxxxxxxEBhE̕\
  ShowWindow( m_hWnd,  !m_pSettings->m_bVisible ? SW_HIDE : SW_SHOWNOACTIVATE );

  return;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	fXgN^
		EChE̔j
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
Gandharva::~Gandharva()
{
  //xxxxxxxxxxxxxxxxxxxx winampt@NV
  if(m_pWinampFunc)
    delete m_pWinampFunc;

  //xxxxxxxxxxxxxxxxxxxx Ia`mf̍폜
  if(m_pSettings && m_pSettings->m_swCmdMode){
    RemoveBangCommand("!GandharvaCmdExtension");
    RemoveBangCommand("!GandharvaCmdPower");
    RemoveBangCommand("!GandharvaCmdOpenFile");
    RemoveBangCommand("!GandharvaCmdPLEdit");
    RemoveBangCommand("!GandharvaCmdNext");
    RemoveBangCommand("!GandharvaCmdStop");
    RemoveBangCommand("!GandharvaCmdPause");
    RemoveBangCommand("!GandharvaCmdPlay");
    RemoveBangCommand("!GandharvaCmdPrev");
  }

  RemoveBangCommand("!GandharvaSndvol");
  RemoveBangCommand("!GandharvaDispMenu");
  RemoveBangCommand("!GandharvaHide");
  RemoveBangCommand("!GandharvaShow");
  RemoveBangCommand("!GandharvaToggleTime");
  RemoveBangCommand("!GandharvaToggle");

  //xxxxxxxxxxxxxxxxxxxx W[o^̔j
  SendMessage( m_hLitestep, LM_UNREGISTERMESSAGE, (WPARAM) m_hWnd, (LPARAM) nMessages );

  //xxxxxxxxxxxxxxxxxxxx ^C}[̍폜ݒNX̍폜
  if(m_rtimer)
    KillTimer(m_hWnd, TIMERID_RECYCLE_DISPLAY);
  if(m_stimer)
    KillTimer(m_hWnd, TIMERID_SCROLL_INTERVAL);

  if(m_pSettings){
    delete m_pSettings;
    m_pSettings = NULL;
  }
  //xxxxxxxxxxxxxxxxxxxx EChEiNXj̔j
  DestroyWindow( m_hWnd );
  m_hWnd = NULL;

  UnregisterClass( WINDOWCLASS_DLL, m_hInstance );

  return;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	EChËړ
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void Gandharva::SetWndPos()
{
  int x,y;

  x = m_pSettings->m_PosX;
  y = m_pSettings->m_PosY;

  if(m_pSettings->m_bXFromCenter) {
    x += GetSystemMetrics(SM_CXSCREEN)/2;
  } else {
    if(x < 0)
      x += GetSystemMetrics(SM_CXSCREEN);
  }

  if(m_pSettings->m_bYFromCenter) {
    y += GetSystemMetrics(SM_CYSCREEN)/2;
  } else {
    if(y < 0)
      y += GetSystemMetrics(SM_CYSCREEN);
  }

  SetWindowPos(m_hWnd, NULL, x, y, 0, 0, SWP_NOSIZE|SWP_NOACTIVATE|SWP_NOZORDER);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	EChEvV[W
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
LRESULT CALLBACK Gandharva::WndProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam)
{
  Gandharva *pGandharva;

  // EChE쐬O
  if(message == WM_NCCREATE){
    LPCREATESTRUCT lpcs = (LPCREATESTRUCT)lparam;
    pGandharva = (Gandharva *)lpcs->lpCreateParams;

    SetWindowLong(hwnd, 0, (long)pGandharva);
  }else
    pGandharva = (Gandharva *)GetWindowLong(hwnd, 0);

  if(pGandharva)
    //vV[W
    return pGandharva->WindowProc(hwnd, message, wparam, lparam);

  // C̃|C^߂Ȃꍇ
  return DefWindowProc(hwnd, message, wparam, lparam);
}

//Gandharva::WindowProc
BEGIN_MESSAGE_PROC(Gandharva)
  MESSAGEFUNC(onPaint,			WM_PAINT);
  MESSAGEFUNC(onTimer,			WM_TIMER);
  MESSAGEFUNC(onDisplayChange,	WM_DISPLAYCHANGE);
  MESSAGEFUNC(onMouse,			WM_LBUTTONDBLCLK);
  MESSAGEFUNC(onMouse,			WM_LBUTTONUP);
  MESSAGEFUNC(onMouse,			WM_RBUTTONDBLCLK);
  MESSAGEFUNC(onMouse,			WM_RBUTTONUP);
  MESSAGEFUNC(onUser,			WM_USER);
  MESSAGEFUNC(onLmGetRevid,		LM_GETREVID);
END_MESSAGE_PROC




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	W[̃o[Wn
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void Gandharva::onLmGetRevid(UINT message, WPARAM wparam, LPARAM lparam, LRESULT *plresult)
{
  UINT mode = (UINT)wparam;
  char *buffer = (char *)lparam;

  if(!buffer)
    return;

  //xxxxxxxxxxxxxxxxxxxx }ʎq̐ݒ
#if defined _A2UNVLIB

#if defined _WINAMP3_ALPHA
 #define _BRANCH TEXT("(uw3)")
#else
 #define _BRANCH TEXT("(u)")
#endif

#else //_A2UNVLIB

#if defined _WINAMP3_ALPHA
 #define _BRANCH TEXT("(w3)")
#endif

#endif //_A2UNVLIB

  //xxxxxxxxxxxxxxxxxxxx o[W
  switch(mode){
#if defined _DEBUG
  case 0:
    sprintf(buffer, "%s:debug%s %s %s", BUILD_NAME, _BRANCH, __DATE__, __TIME__);
    break;
#else
  case 0:
    sprintf(buffer, "%s:%s%s", BUILD_NAME, BUILD_VERSION, _BRANCH);
    break;
#endif //_DEBUG

  case 1:
    sprintf(buffer, "Id:%s %s%s %s %s", BUILD_NAME, BUILD_VERSION, _BRANCH, BUILD_DATE, BUILD_AUTHOR);
    break;

  default:
    strcpy(buffer, "");
    break;
  }

  *plresult = (LRESULT)strlen(buffer);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	EChE̕`
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void Gandharva::onPaint(UINT message, WPARAM wparam, LPARAM lparam, LRESULT *plresult)
{
  HDC hdcScreen;
  HDC hdcTemp;
  HBITMAP hbmTemp,hbmOld;

  //xxxxxxxxxxxxxxxxxxxx `Jn
  PAINTSTRUCT ps;
  hdcScreen = BeginPaint(m_hWnd, &ps);

  //xxxxxxxxxxxxxxxxxxxx enh̍쐬
  hdcTemp = CreateCompatibleDC(hdcScreen);
  hbmTemp = CreateCompatibleBitmap(hdcScreen, m_pSettings->m_Width, m_pSettings->m_Height);

  //xxxxxxxxxxxxxxxxxxxx rbg}bv̓KpƃobNAbv
  hbmOld = SelectBitmap(hdcTemp, hbmTemp);

  //xxxxxxxxxxxxxxxxxxxx wi̕`
  m_pSettings->PaintBG(hdcTemp);

  //xxxxxxxxxxxxxxxxxxxx eLXgdˍ킹
  if(m_pWinampFunc) {
    //winamp ԕ\
    if(m_pSettings->m_bTimeEnable){
      m_pSettings->PaintTime(hdcTemp);
    }
  }
  //^Cg\
  int bcx,bcy;
  GetLSBitmapSize(m_pSettings->m_hbmTitle, &bcx, &bcy);
  if(m_pSettings->m_bTitleScroll && bcx > m_pSettings->m_Width -(m_pSettings->m_nPaddingRight+m_pSettings->m_nPaddingLeft)){
    m_pSettings->PaintText(hdcTemp);
    if(!m_stimer)
      m_stimer = SetTimer(m_hWnd, TIMERID_SCROLL_INTERVAL, m_pSettings->m_nScrollInterval, NULL);
  } else {
    m_pSettings->PaintTextNoScroll(hdcTemp);
    if(m_stimer){
      KillTimer(m_hWnd, TIMERID_SCROLL_INTERVAL);
      m_stimer = NULL;
    }
  }

  //xxxxxxxxxxxxxxxxxxxx wi߂H

  //xxxxxxxxxxxxxxxxxxxx EBhEɓ]
  BitBlt(hdcScreen, 0, 0, m_pSettings->m_Width, m_pSettings->m_Height, hdcTemp, 0, 0, SRCCOPY);

  //xxxxxxxxxxxxxxxxxxxx enh̔j
  EndPaint(m_hWnd, &ps);

  SelectBitmap(hdcTemp, hbmOld);

  DeleteBitmap(hbmTemp);
  DeleteDC(hdcTemp);

  *plresult = 0;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	^C}[
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void Gandharva::onTimer(UINT message, WPARAM wparam, LPARAM lparam, LRESULT *plresult)
{
  LPSTR lpszbuf = new char [2048];
  long amptime;
  
  switch(wparam) {
  case TIMERID_RECYCLE_DISPLAY:
    // ԕ\̍XV
    if(m_pSettings->m_bTimeEnable) {
      if(m_pSettings->m_bTimeRemain) {
        amptime = m_pWinampFunc->GetPlaybackTime(GPT_REMAIN);
        if(-1 == amptime)
          strcpy(lpszbuf, "-00:00");
        else
          sprintf(lpszbuf, "-%02d:%02d", amptime/60, amptime%60);
      } else {
        amptime = m_pWinampFunc->GetPlaybackTime(GPT_ELAPSED);
        if(-1 == amptime)
          strcpy(lpszbuf, " 00:00");
        else
          sprintf(lpszbuf, " %02d:%02d", amptime/60, amptime%60);
      }
      if(m_pSettings->m_hbmTime)
        DeleteBitmap(m_pSettings->m_hbmTime);
      m_pSettings->m_hbmTime = m_pSettings->CreateTextBitmap(lpszbuf, m_pSettings->m_TimeLogFont, m_pSettings->m_TimeFontColor);
    }
    // ^Cg\̍XV
    if(m_pWinampFunc) {
      if(m_pWinampFunc->GetTitle(lpszbuf, GWT_REFRESH)) {
        //^CgXVꂽ
        m_pSettings->m_nScrollOffset = 0;
        m_pWinampFunc->SetFormat(lpszbuf, !m_pSettings->m_bKeepPrefix, !m_pSettings->m_bKeepSuffix);
        if(m_pSettings->m_hbmTitle)
          DeleteBitmap(m_pSettings->m_hbmTitle);
        m_pSettings->m_hbmTitle = m_pSettings->CreateTextBitmap(lpszbuf, m_pSettings->m_TextLogFont, m_pSettings->m_FontColor);
      }
    } else {
      //winamp class error
      if(m_pSettings->m_hbmTitle)
        DeleteBitmap(m_pSettings->m_hbmTitle);
      m_pSettings->m_hbmTitle = m_pSettings->CreateTextBitmap("winamp class error.", m_pSettings->m_TextLogFont, m_pSettings->m_FontColor);
    }
    InvalidateRect(m_hWnd, NULL, FALSE);
    break;

  case TIMERID_SCROLL_INTERVAL:
    m_pSettings->m_nScrollOffset += m_pSettings->m_nScrollStep;
    InvalidateRect(m_hWnd, NULL, FALSE);
    break;
  }

  delete lpszbuf;
  *plresult = 0;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	fBXvC̉𑜓xύXꂽƂ
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void Gandharva::onDisplayChange(UINT message, WPARAM wparam, LPARAM lparam, LRESULT *plresult)
{
  SetWndPos();
  *plresult = 0;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	}EXCxg
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void Gandharva::onMouse(UINT message, WPARAM wparam, LPARAM lparam, LRESULT *plresult)
{
  DWORD cmap = ParseClickMap(LOWORD(lparam), HIWORD(lparam));

  switch(message) {
  case WM_LBUTTONUP: //Left Button Click
    if(MyParseBangCommand(m_pSettings->m_lpszMouseALLC)) break;

    if(PCM_TITLE & cmap) { MyParseBangCommand(m_pSettings->m_lpszMouseTTLC); break; }
    if(PCM_TIME & cmap)  { MyParseBangCommand(m_pSettings->m_lpszMouseTMLC); break; }

    break;

  case WM_RBUTTONUP: //Right Button Click
    if(MyParseBangCommand(m_pSettings->m_lpszMouseALRC)) break;

    if(PCM_TITLE & cmap){ MyParseBangCommand(m_pSettings->m_lpszMouseTTRC); break; }
    if(PCM_TIME & cmap) { MyParseBangCommand(m_pSettings->m_lpszMouseTMRC); break; }

    break;

  case WM_LBUTTONDBLCLK: //Left Button Double Click
    if(MyParseBangCommand(m_pSettings->m_lpszMouseALLD)) break;

    if(PCM_TITLE & cmap){ MyParseBangCommand(m_pSettings->m_lpszMouseTTLD); break; }
    if(PCM_TIME & cmap) { MyParseBangCommand(m_pSettings->m_lpszMouseTMLD); break; }

    break;

  case WM_RBUTTONDBLCLK: //Right Botton Dbl Click
    if(MyParseBangCommand(m_pSettings->m_lpszMouseALRD)) break;

    if(PCM_TITLE & cmap) { MyParseBangCommand(m_pSettings->m_lpszMouseTTRD); break ;}
    if(PCM_TIME & cmap)  { MyParseBangCommand(m_pSettings->m_lpszMouseTMRD); break ;}

    break;
  }
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	}EXCxg̍W
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
DWORD Gandharva::ParseClickMap(int mx, int my)
{
  DWORD dwresult=0;

  if(m_pSettings->m_nPaddingLeft <= mx &&
     m_pSettings->m_Width - m_pSettings->m_nPaddingRight >= mx &&
     m_pSettings->m_nPaddingTop <= my &&
     m_pSettings->m_Height - m_pSettings->m_nPaddingBottom >= my)
      dwresult |= PCM_TITLE;
      
  if(m_pSettings->m_nATPaddingLeft <= mx &&
     m_pSettings->m_Width - m_pSettings->m_nATPaddingRight >= mx &&
     m_pSettings->m_nATPaddingTop <= my &&
     m_pSettings->m_Height - m_pSettings->m_nATPaddingBottom >= my)
      dwresult |= PCM_TIME;

  return dwresult;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	ParseBangCommand wrapper
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
BOOL Gandharva::MyParseBangCommand(char *command)
{
  if(!command)
    return FALSE;

  LPSTR lpszcmd,lpszargs;
  BOOL result;

  lpszcmd = new char[1024];

  //copy to temp buffer
  strcpy(lpszcmd, command);

  //It has token(s)?
  lpszargs = (LPSTR)_tcschr(lpszcmd, ' ');

  if(lpszargs)
    *lpszargs++ = NULL;

  //support .exe file
  if(*lpszcmd != '!'){
    ShellExecute(m_hWnd, NULL, lpszcmd, lpszargs, NULL, SW_SHOWNORMAL);
    result = TRUE;
  } else {
    result = ParseBangCommand(m_hWnd, lpszcmd, lpszargs);
  }
  delete lpszcmd;
  
  return result;
}

/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	!bang 
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
REDIRECT_BANG(Gandharva, bangToggleVisible,	USERBM_TOGGLE)
REDIRECT_BANG(Gandharva, bangToggleTime,	USERBM_TOGGLE_TIME)
REDIRECT_BANG(Gandharva, bangShow,			USERBM_SHOW)
REDIRECT_BANG(Gandharva, bangHide,			USERBM_HIDE)
REDIRECT_BANG(Gandharva, bangDispMenu,		USERBM_DISPMENU)
REDIRECT_BANG(Gandharva, bangRunSndvol,		USERBM_SNDVOL)
REDIRECT_BANG(Gandharva, bangAmpPower,  	USERBM_AMP_POWER)
REDIRECT_BANG(Gandharva, bangAmpCommand,	USERBM_AMP_COMMANDEX)

void Gandharva::onUser(UINT message, WPARAM wparam, LPARAM lparam, LRESULT* plresult)
{
  HWND hwnd;

  // winamp R}h
  if(wparam>40000){
    *plresult = ParseAmpCommand(wparam);
    return;
  }

  //!bang {
  switch(wparam){
  case USERBM_SHOW: //!GandharvaShow
    ShowWindow(m_hWnd, SW_SHOWNOACTIVATE);
    break;

  case USERBM_HIDE: //!GandharvaHide
    ShowWindow(m_hWnd, SW_HIDE);
    break;

  case USERBM_TOGGLE: //!GandharvaToggle
    if( IsWindowVisible(m_hWnd) )
      ShowWindow(m_hWnd, SW_HIDE);
    else
      ShowWindow(m_hWnd, SW_SHOWNOACTIVATE);
    break;

  case USERBM_TOGGLE_TIME: //toggletime
    m_pSettings->m_bTimeRemain=(m_pSettings->m_bTimeRemain)?FALSE:TRUE;
    onTimer(WM_TIMER, TIMERID_RECYCLE_DISPLAY, 0, plresult);
    break;

  case USERBM_DISPMENU: //dispmenu
    m_pWinampFunc->DisplayMainMenu();
    break;

  case USERBM_SNDVOL: //sndvol
    hwnd = FindWindow("Volume Control", NULL);

    if(!hwnd)
      ShellExecute(m_hWnd, NULL, "sndvol32.exe", NULL, NULL, SW_SHOWNORMAL);
    else
      SetForegroundWindow(hwnd);

    break;

  case USERBM_AMP_POWER: //cmdpower
    if( m_pWinampFunc->FindWindow() )
      m_pWinampFunc->Close();
    else
      m_pWinampFunc->ExecuteEx(NULL, m_pSettings->m_bVisibleAmp);
    break;

  case USERBM_AMP_COMMANDEX: //cmdextension
    *plresult = ParseAmpCommand( lparam );
    break;

  default:
    *plresult=1;
    return;
  }
  *plresult = 0;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	!bang  winamp message
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
REDIRECT_BANG(Gandharva, bangAmpPrev,	AMPAPI_CMD_PREV)
REDIRECT_BANG(Gandharva, bangAmpPlay,	AMPAPI_CMD_PLAY)
REDIRECT_BANG(Gandharva, bangAmpPause,	AMPAPI_CMD_PAUSE)
REDIRECT_BANG(Gandharva, bangAmpStop,	AMPAPI_CMD_STOP)
REDIRECT_BANG(Gandharva, bangAmpNext,	AMPAPI_CMD_NEXT)
REDIRECT_BANG(Gandharva, bangAmpPLEdit,	AMPAPI_CMD_PLEDIT)
REDIRECT_BANG(Gandharva, bangAmpOpenFile,AMPAPI_CMD_OPENFILE)

LRESULT Gandharva::ParseAmpCommand(DWORD command)
{
  //xxxxxxxxxxxxxxxxxxxx JĂȂ͈͂̃bZ[W̓tB^O
  if(command <= 40000 || 40299 <= command)
    return 1;

  //xxxxxxxxxxxxxxxxxxxx 
  HWND hwinamp = m_pWinampFunc->FindWindow();

  switch(command){
  case AMPAPI_CMD_PLAY: //cmdplay
    if(!hwinamp){
      m_pWinampFunc->ExecuteEx(NULL, m_pSettings->m_bVisibleAmp);
      return 0;
    }
    break;
  case AMPAPI_CMD_PLEDIT: //cmdpledit
  case AMPAPI_CMD_OPENFILE: //cmpopenfile
    if(hwinamp)
      SetWindowPos(hwinamp, HWND_TOP, 0, 0, 0, 0, SWP_NOSIZE|SWP_NOMOVE);
    break;
  }

  //xxxxxxxxxxxxxxxxxxxxR}h𑗂
  m_pWinampFunc->PostCommand(command);
  return 0;
}
