// $Id: GandharvaSettings.cpp,v 1.16 2001/06/12 10:48:55 Yoshi Exp $
// Copyright (C) 2000,2001 HOSHINO Yoshifumi
// {vO̓t[E\tgEFAłBρEĔzz GNU GPL o[WQ
// i͂ȍ~jQƂĂB

#include "GandharvaSettings.h"
#include "lsapi.h"
#include <stdlib.h>
#include <windowsx.h>

#if defined _A2UNVLIB
#include <a2unvlib.h>
#endif


/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	RXgN^Őݒǂݍ
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
GandharvaSettings::GandharvaSettings(HWND owner)
{
  LPSTR lpszbuf = new char[1024];
  char token[4][4];
  char *tokens[]={token[0], token[1], token[2], token[3], 0};

  //xxxxxxxxxxxxxxxxxxxx VXep[^
  m_hWnd = owner;
  m_hbmBack = NULL;
  m_hbmSkin = NULL;
  m_hbmTitle= NULL;
  m_hbmTime = NULL;

  m_lpszMouseALLC = NULL;
  m_lpszMouseALRC = NULL;
  m_lpszMouseALLD = NULL;
  m_lpszMouseALRD = NULL;

  m_lpszMouseTTLC = NULL;
  m_lpszMouseTTRC = NULL;
  m_lpszMouseTTLD = NULL;
  m_lpszMouseTTRD = NULL;

  m_lpszMouseTMLC = NULL;
  m_lpszMouseTMRC = NULL;
  m_lpszMouseTMLD = NULL;
  m_lpszMouseTMRD = NULL;

  //xxxxxxxxxxxxxxxxxxxx TextLogFont
  //m_TextLogFont.lfHeight;
  m_TextLogFont.lfWidth = 0;
  m_TextLogFont.lfEscapement = 0;
  m_TextLogFont.lfOrientation = 0;
  //m_TextLogFont.lfWeight;
  //m_TextLogFont.lfItalic;
  m_TextLogFont.lfUnderline = FALSE;
  m_TextLogFont.lfStrikeOut = FALSE;
  m_TextLogFont.lfCharSet = DEFAULT_CHARSET;
  m_TextLogFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
  m_TextLogFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
  m_TextLogFont.lfQuality = DEFAULT_QUALITY;
  m_TextLogFont.lfPitchAndFamily = DEFAULT_PITCH|FF_DONTCARE;
  //m_TextLogFont.lfFaceName[LF_FACESIZE];

  //xxxxxxxxxxxxxxxxxxxx {ݒ
  GetRCString("GandharvaFont", m_TextLogFont.lfFaceName, "MS UI Gothic", LF_FACESIZE);
  m_TextLogFont.lfHeight =GetRCInt("GandharvaFontSize", 16);
  m_FontColor	=GetRCColor("GandharvaFontColor", 0xFFFFFF);
  m_BGColor		=GetRCColor("GandharvaBGColor", 0x000000);
  m_BorderColor	=GetRCColor("GandharvaBorderColor", 0x888888);

  if(GetRCBool("GandharvaForceTransp", TRUE))
    m_TranspColor = m_BGColor;
  else
    m_TranspColor = 0xFF00FF;

  m_bTitleScroll = GetRCBool("GandharvaAutoScroll", TRUE);

  m_TextLogFont.lfItalic = GetRCBool("GandharvaFontItalic", TRUE);
  if(GetRCBool("GandharvaFontBold", TRUE))
    m_TextLogFont.lfWeight = 700;
  else
    m_TextLogFont.lfWeight = 400;

  //m_PosX = GetRCInt("GandharvaX", 0);
  GetRCString("GandharvaX", lpszbuf, "", 64);
  if(toupper(*lpszbuf) == 'C') {
    m_bXFromCenter=TRUE;
    m_PosX = atoi(lpszbuf+1);
  } else {
    m_bXFromCenter=FALSE;
    m_PosX = atoi(lpszbuf);
  }

  //m_PosY = GetRCInt("GandharvaY", 0);
  GetRCString("GandharvaY", lpszbuf, "", 64);
  if(toupper(*lpszbuf) == 'C') {
    m_bYFromCenter=TRUE;
    m_PosY = atoi(lpszbuf+1);
  } else {
    m_bYFromCenter=FALSE;
    m_PosY = atoi(lpszbuf);
  }

  
  m_Width= GetRCInt("GandharvaWidth", 180);
  m_Height=GetRCInt("GandharvaHeight", 20);

  // bitmap
  GetRCString("GandharvaBitmap", lpszbuf, "", MAX_PATH);

  if(*lpszbuf){
    m_hbmSkin = LoadLSImage(lpszbuf, NULL);

    //rbg}bvɂ킹ăTCYC
    if(m_hbmSkin)
      GetLSBitmapSize(m_hbmSkin, &m_Width, &m_Height);
  }

  //xxxxxxxxxxxxxxxxxxxxgݒ
  GetRCString("GandharvaDefaultString", m_lpszTitleDefault, "", 128);

  //window style
  m_bAlwaysOnTop = GetRCBool("GandharvaAlwaysOnTop", TRUE);
  m_bVisible = GetRCBool("GandharvaHidden", FALSE);

  //border
  GetRCLine("GandharvaBorderSize", lpszbuf, MAX_RCCOMMAND, "0");

  if(4 == LCTokenize(lpszbuf, NULL, 0, NULL)){
    LCTokenize(lpszbuf, tokens, 4, NULL);

    m_nBorderTop   =atoi(token[0]);
    m_nBorderRight =atoi(token[1]);
    m_nBorderBottom=atoi(token[2]);
    m_nBorderLeft  =atoi(token[3]);
  }else
    m_nBorderTop = m_nBorderRight = m_nBorderBottom = m_nBorderLeft = GetRCInt("GandharvaBorderSize", 0);

  //padding
  GetRCLine("GandharvaPadding", lpszbuf, MAX_RCCOMMAND, "0");

  if(4 == LCTokenize(lpszbuf, NULL, 0, NULL)){
    LCTokenize(lpszbuf, tokens, 4, NULL);

    m_nPaddingTop   =atoi(token[0]);
    m_nPaddingRight =atoi(token[1]);
    m_nPaddingBottom=atoi(token[2]);
    m_nPaddingLeft  =atoi(token[3]);
  }else
    m_nPaddingTop = m_nPaddingRight = m_nPaddingBottom = m_nPaddingLeft = atoi(lpszbuf);

  //scroll
  m_nScrollInterval = GetRCInt("GandharvaScrollInterval", 500);
  if(m_nScrollInterval < 1)
    m_nScrollInterval = 500;

  m_nScrollStep = GetRCInt("GandharvaScrollStep", 4);
  if(m_nScrollStep < 1)
    m_nScrollStep = 4;

  //prefix suffix
  m_bKeepPrefix = GetRCBool("GandharvaKeepPrefix", TRUE);
  m_bKeepSuffix = GetRCBool("GandharvaKeepSuffix", TRUE);

  //!command mode
  GetRCString("GandharvaCommandMode", lpszbuf, "basic", 64);

  if(!strcmpi(lpszbuf, "none"))	m_swCmdMode=CMDMODE_NONE;
  if(!strcmpi(lpszbuf, "basic"))	m_swCmdMode=CMDMODE_BASIC;
  if(!strcmpi(lpszbuf, "extension")) m_swCmdMode=CMDMODE_BASIC; //old version

  //text align
  GetRCString("GandharvaTextAlignH", lpszbuf, "left", 64);

  if(!strcmpi(lpszbuf, "left")) m_swTextAlignH=ALIGN_LEFT;
  if(!strcmpi(lpszbuf, "right")) m_swTextAlignH=ALIGN_RIGHT;
  if(!strcmpi(lpszbuf, "center")) m_swTextAlignH=ALIGN_CENTER;

  //Winamp showing option on execution
  m_bVisibleAmp = GetRCBool("GandharvaHiddenAmp" , FALSE);

  //xxxxxxxxxxxxxxxxxxxx time display
  memcpy(&m_TimeLogFont, &m_TextLogFont, sizeof(LOGFONT));

  GetRCString("GandharvaTime", lpszbuf, "", MAX_RCCOMMAND);

  if(!stricmp(lpszbuf, "elapsed")){
    m_bTimeEnable = TRUE;
    m_bTimeRemain = FALSE;
  }else if(!stricmp(lpszbuf, "remain")){
    m_bTimeEnable = TRUE;
    m_bTimeRemain = TRUE;
  }else{
    m_bTimeEnable = FALSE;
    m_bTimeRemain = FALSE;
  }

  //font config(init with TITLE font var)
  if(GetRCString("GandharvaTimeFont", lpszbuf, "", LF_FACESIZE))
    strcpy(m_TimeLogFont.lfFaceName, lpszbuf);

  m_TimeFontColor =GetRCColor("GandharvaTimeFontColor", m_FontColor);

  m_TimeLogFont.lfHeight = GetRCInt("GandharvaTimeFontSize",    m_TextLogFont.lfHeight);
  m_TimeLogFont.lfItalic = GetRCBool("GandharvaTimeFontItalic", TRUE);

  if(GetRCBool("GandharvaTimeFontBold", TRUE))
    m_TimeLogFont.lfWeight = 700;
  else
    m_TimeLogFont.lfWeight = 400;

  //time padding
  GetRCLine("GandharvaTimePadding", lpszbuf, MAX_RCCOMMAND, "0");

  if(4 == LCTokenize(lpszbuf, NULL, 0, NULL)){
    LCTokenize(lpszbuf, tokens, 4, NULL);

    m_nATPaddingTop   =atoi(token[0]);
    m_nATPaddingRight =atoi(token[1]);
    m_nATPaddingBottom=atoi(token[2]);
    m_nATPaddingLeft  =atoi(token[3]);
  }else
    m_nATPaddingTop = m_nATPaddingRight = m_nATPaddingBottom = m_nATPaddingLeft = atoi(lpszbuf);

  //xxxxxxxxxxxxxxxxxxxx mouse event mapping
  m_bMouseRemap = GetRCBool("GandharvaMouseRemap", TRUE);

  if(m_bMouseRemap) {
    //.rc Ɏw肪 ǂݍŁAnew Ńobt@m
    LAYOUT_MOUSE_MAP("GandharvaMouseALLC", m_lpszMouseALLC);
    LAYOUT_MOUSE_MAP("GandharvaMouseALLD", m_lpszMouseALLD);
    LAYOUT_MOUSE_MAP("GandharvaMouseALRC", m_lpszMouseALRC);
    LAYOUT_MOUSE_MAP("GandharvaMouseALRD", m_lpszMouseALRD);

    LAYOUT_MOUSE_MAP("GandharvaMouseTTLC", m_lpszMouseTTLC);
    LAYOUT_MOUSE_MAP("GandharvaMouseTTLD", m_lpszMouseTTLD);
    LAYOUT_MOUSE_MAP("GandharvaMouseTTRC", m_lpszMouseTTRC);
    LAYOUT_MOUSE_MAP("GandharvaMouseTTRD", m_lpszMouseTTRD);

    LAYOUT_MOUSE_MAP("GandharvaMouseTMLC", m_lpszMouseTMLC);
    LAYOUT_MOUSE_MAP("GandharvaMouseTMLD", m_lpszMouseTMLD);
    LAYOUT_MOUSE_MAP("GandharvaMouseTMRC", m_lpszMouseTMRC);
    LAYOUT_MOUSE_MAP("GandharvaMouseTMRD", m_lpszMouseTMRD);
  } else {
    //default
    m_lpszMouseALRC = new char[1+sizeof("!GandharvaDispMenu")];
    strcpy(m_lpszMouseALRC, "!GandharvaDispMenu");

    m_lpszMouseTTLD = new char[1+sizeof("!GandharvaSndvol")];
    strcpy(m_lpszMouseTTLD, "!GandharvaSndvol");

    m_lpszMouseTMLC = new char[1+sizeof("!GandharvaToggleTime")];
    strcpy(m_lpszMouseTMLC, "!GandharvaToggleTime");
  }
  //xxxxxxxxxxxxxxxxxxxx ꎞobt@̔j
  delete lpszbuf;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	fXgN^
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
GandharvaSettings::~GandharvaSettings()
{
  if(m_lpszMouseALLC) delete m_lpszMouseALLC;
  if(m_lpszMouseALRC) delete m_lpszMouseALRC;
  if(m_lpszMouseALLD) delete m_lpszMouseALLD;
  if(m_lpszMouseALRD) delete m_lpszMouseALRD;

  if(m_lpszMouseTTLC) delete m_lpszMouseTTLC;
  if(m_lpszMouseTTRC) delete m_lpszMouseTTRC;
  if(m_lpszMouseTTLD) delete m_lpszMouseTTLD;
  if(m_lpszMouseTTRD) delete m_lpszMouseTTRD;

  if(m_lpszMouseTMLC) delete m_lpszMouseTMLC;
  if(m_lpszMouseTMRC) delete m_lpszMouseTMRC;
  if(m_lpszMouseTMLD) delete m_lpszMouseTMLD;
  if(m_lpszMouseTMRD) delete m_lpszMouseTMRD;

  if(m_hbmSkin)		DeleteBitmap(m_hbmSkin);
  if(m_hbmBack)		DeleteBitmap(m_hbmBack);
  if(m_hbmTitle)	DeleteBitmap(m_hbmTitle);
  if(m_hbmTime)		DeleteBitmap(m_hbmTime);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	wȉo
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::PaintBG(HDC hdcdst)
{
  HDC hdc;
  HBITMAP hbmold;
  
  //xxxxxxxxxxxxxxxxxxxx wi̍쐬͂܂H
  if( !m_hbmBack )
    CreateBG();

  //xxxxxxxxxxxxxxxxxxxx wiRs[
  hdc    = CreateCompatibleDC(hdcdst);
  hbmold = SelectBitmap(hdc, m_hbmBack);

  BitBlt(hdcdst, 0, 0, m_Width, m_Height, hdc, 0, 0, SRCCOPY);

  SelectBitmap(hdc, hbmold);
  DeleteDC(hdc);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	wi̍쐬
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::CreateBG()
{
  HDC	hdcScreen, hdcBack, hdcSkin;
  HBITMAP hbmBackOld, hbmSkinOld;
  RECT rect;
  HBRUSH hbrush;

  //xxxxxxxxxxxxxxxxxxxx EChERp`DC,BMP
  hdcScreen = GetDC(m_hWnd);
  hdcBack = CreateCompatibleDC(hdcScreen);
  m_hbmBack = CreateCompatibleBitmap(hdcScreen, m_Width, m_Height);

  hbmBackOld = SelectBitmap(hdcBack, m_hbmBack);

  //xxxxxxxxxxxxxxxxxxxx ǎ؂ăEBhEɒtiȂ񂿂ē߁j
  PaintDesktop(hdcScreen);
  BitBlt(hdcBack, 0, 0, m_Width, m_Height, hdcScreen, 0, 0, SRCCOPY);

  //xxxxxxxxxxxxxxxxxxxx XL
  if(m_hbmSkin) {
    hdcSkin = CreateCompatibleDC(hdcBack);
    hbmSkinOld = SelectBitmap(hdcSkin, m_hbmSkin);

    TransparentBltLS(hdcBack, 0, 0, m_Width, m_Height, hdcSkin, 0, 0, 0xFF00FF);

    SelectBitmap(hdcSkin, hbmSkinOld);
    DeleteDC(hdcBack);
  } else {
    //xxxxxxxxxxxxxxxxxxxx g
    if(m_BorderColor != m_TranspColor){
      hbrush = CreateSolidBrush(m_BorderColor);

      rect.left = 0;
      rect.top = 0;
      rect.right = m_Width;
      rect.bottom = m_nBorderTop;

      if(m_nBorderTop)
        FillRect(hdcBack, &rect, hbrush);

      rect.top = m_Height - m_nBorderBottom;
      rect.bottom = m_Height;

      if(m_nBorderBottom)
        FillRect(hdcBack, &rect, hbrush);

      rect.top = 0;
      rect.right = m_nBorderLeft;

      if(m_nBorderLeft)
        FillRect(hdcBack, &rect, hbrush);

      rect.left = m_Width - m_nBorderRight;
      rect.right = m_Width;

      if(m_nBorderRight)
        FillRect(hdcBack, &rect, hbrush);

      DeleteBrush(hbrush);
    }

    //xxxxxxxxxxxxxxxxxxxx obNOEh
    if(m_BGColor != m_TranspColor){
      rect.left = m_nBorderLeft;
      rect.top = m_nBorderTop;
      rect.right = m_Width - m_nBorderRight;
      rect.bottom = m_Height - m_nBorderBottom;

      hbrush = CreateSolidBrush(m_BGColor);
      FillRect(hdcBack, &rect, hbrush);
      DeleteBrush(hbrush);
    }
  }
  //xxxxxxxxxxxxxxxxxxxx ㏈
  SelectBitmap(hdcBack, hbmBackOld);
  DeleteDC(hdcBack);

  ReleaseDC(m_hWnd, hdcScreen);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	^Cg̃rbg}bv쐬
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
HBITMAP GandharvaSettings::CreateTextBitmap(LPSTR lpszTextStr, LOGFONT lf, COLORREF color)
{
  HDC hdcwnd,hmemdc;
  HBITMAP hbitmap,hbmold;
  HFONT hfont,hfontold;
  SIZE size;
  long textlen;

  //͓KH
  if(!lpszTextStr)
    return NULL;

  textlen= strlen(lpszTextStr);
  if(!textlen)
    return NULL;

  //rbg}bṽTCY𒲂ׂ
  hmemdc = CreateCompatibleDC(NULL);

#if defined _A2UNVLIB
  hfont = CreateFontIndirectC(&lf);
#else
  hfont = CreateFontIndirect(&lf);
#endif
  
  hfontold = SelectFont(hmemdc, hfont);
  GetTextExtentPoint32(hmemdc, lpszTextStr, textlen, &size);
  SelectFont(hmemdc, hfontold);
  DeleteDC(hmemdc);

  //߂
  hmemdc = CreateCompatibleDC(NULL);
  hfontold = SelectFont(hmemdc, hfont);

  hdcwnd = GetDC(m_hWnd);
  hbitmap = CreateCompatibleBitmap(hdcwnd, size.cx, size.cy);
  ReleaseDC(m_hWnd, hdcwnd);

  if(hbitmap) {
    hbmold = SelectBitmap(hmemdc, hbitmap);

    //Fw
    SetTextColor(hmemdc, color);
    SetBkColor(hmemdc, m_BGColor);

    //`
    TextOut(hmemdc, 0, 0, lpszTextStr, textlen);

    SelectBitmap(hmemdc, hbmold);
  }
  
  //n
  SelectFont(hmemdc, hfontold);

  DeleteFont(hfont);
  DeleteDC(hmemdc);

  return hbitmap;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	ԕ\rbg}bv쐬
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::PaintTime(HDC hdcDst)
{
  int cx,cy;
  HDC hdctemp = CreateCompatibleDC(NULL);
  HBITMAP hbmold = SelectBitmap(hdctemp, m_hbmTime);

  GetLSBitmapSize(m_hbmTime, &cx, &cy);

  TransparentBltLS(hdcDst,
                   m_nATPaddingLeft,
                   m_nATPaddingTop,
                   min(m_Width-(m_nATPaddingRight+m_nATPaddingLeft), cx),
                   min(m_Height-(m_nATPaddingBottom+m_nATPaddingTop), cy),
                   hdctemp,
                   0,
                   0,
                   m_TranspColor);

  SelectBitmap(hdctemp, hbmold);
  DeleteDC(hdctemp);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	^Cg\iXN[j
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::PaintText(HDC hdcDst)
{
  HDC hdctext;
  HBITMAP hbmold;
  int dx,dy,dcx,dcy;
  RECT clippedRECT;
  SIZE textSIZE,clippedSIZE;

  int SeparateWidth,SecondOffset;

  if(!m_hbmTitle)
    return;

  GetLSBitmapSize(m_hbmTitle, (int *)&textSIZE.cx, (int *)&textSIZE.cy);

  //xxxxxxxxxxxxxxxxxxxx PaddingSizeɃNbsÖݒ
  clippedRECT.left = m_nPaddingLeft;
  clippedRECT.top = m_nPaddingTop;
  clippedRECT.right = m_Width - m_nPaddingRight;
  clippedRECT.bottom = m_Height - m_nPaddingBottom;

  clippedSIZE.cx = clippedRECT.right - clippedRECT.left;
  clippedSIZE.cy = clippedRECT.bottom - clippedRECT.top;

  //xxxxxxxxxxxxxxxxxxxx XN[̌vZ
  SeparateWidth = clippedSIZE.cx/4;
  SecondOffset = textSIZE.cx - m_nScrollOffset + SeparateWidth;

  //ZJh֐؂n߂ACƌ
  if(SecondOffset <= 0){
    m_nScrollOffset = -SecondOffset;
    SecondOffset = textSIZE.cx - m_nScrollOffset + SeparateWidth;
  }

  //Rs[
  hdctext = CreateCompatibleDC(NULL);
  hbmold = SelectBitmap(hdctext, m_hbmTitle);

  //  [TTTTTTTT]
  //  |---->
  if(m_nScrollOffset < textSIZE.cx){
    dx = clippedRECT.left;
    dy = clippedRECT.top;
    dcx = min(clippedSIZE.cx, textSIZE.cx-m_nScrollOffset);
    dcy = min(clippedSIZE.cy, textSIZE.cy);

    TransparentBltLS(hdcDst, dx, dy, dcx, dcy, hdctext, m_nScrollOffset, 0, m_TranspColor);
  }
  //        |-------->[TTTTTTT]
  //        
  if(SecondOffset < clippedSIZE.cx){
    dx = clippedRECT.left+SecondOffset;
    dy = clippedRECT.top;
    dcx = clippedSIZE.cx-SecondOffset;
    dcy = min(clippedSIZE.cy, textSIZE.cy);

    TransparentBltLS(hdcDst, dx, dy, dcx, dcy, hdctext, 0, 0, m_TranspColor);
  }

  //xxxxxxxxxxxxxxxxxxxxBMP߂
  SelectBitmap(hdctext, hbmold);

  //xxxxxxxxxxxxxxxxxxxxj
  DeleteDC(hdctext);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	^Cg\iXN[j
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::PaintTextNoScroll(HDC hdcDst)
{
  HDC hdctext;
  HBITMAP hbmold;
  int offset,txtcx,txtcy,clipcx,clipcy;

  if(!m_hbmTitle)
    return;

  GetLSBitmapSize(m_hbmTitle, &txtcx, &txtcy);

  //NbsOTCYݒ
  clipcx = m_Width - (m_nPaddingRight+m_nPaddingLeft);
  clipcy = m_Height- (m_nPaddingBottom+m_nPaddingTop);
  
  //align
  switch(m_swTextAlignH){ 
  case ALIGN_RIGHT:
    offset = clipcx - txtcx;
    break;
  case ALIGN_CENTER:
    offset = (clipcx - txtcx)/2;
    break;
  default:
    offset = 0;
    break;
  }

  //xxxxxxxxxxxxxxxxxxxx Rs[
  hdctext = CreateCompatibleDC(NULL);
  hbmold = SelectBitmap(hdctext, m_hbmTitle);

  //
  TransparentBltLS(hdcDst,
                   max(m_nPaddingLeft, m_nPaddingLeft+offset),
                   m_nPaddingTop,
                   min(clipcx,txtcx),
                   min(clipcy,txtcy),
                   hdctext,
                   0,
                   0,
                   m_TranspColor);
  //xxxxxxxxxxxxxxxxxxxxBMP߂
  SelectBitmap(hdctext, hbmold);

  //xxxxxxxxxxxxxxxxxxxxj
  DeleteDC(hdctext);
}
